
--Written by "ihc-433" 
--Update by "Werkstattleiter" und "Ordaton"  NAS-Moddingsquad
--Angepasst fr Unimog TLF by "Grisu118" LS2013.org
--Date: 06.01.2013

U1450_KTLF = {};

function U1450_KTLF.prerequisitesPresent(specializations)
    return true; 
end;

function U1450_KTLF:load(xmlFile)
		--Erster Trigger
	self.Trigger1 = U1450_KTLF.Trigger1;
	self.TriggerIndex1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger1#index"));
	addTrigger(self.TriggerIndex1, "Trigger1", self);
	self.enteredTrigger1 = false;
		--Zweiter Trigger
	self.Trigger2 = U1450_KTLF.Trigger2;
	self.TriggerIndex2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger2#index"));
	addTrigger(self.TriggerIndex2, "Trigger2", self);
	self.enteredTrigger2 = false;
		--dritter Trigger
	self.Trigger3 = U1450_KTLF.Trigger3;
	self.TriggerIndex3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger3#index"));
	addTrigger(self.TriggerIndex3, "Trigger3", self);
	self.enteredTrigger3 = false;
		--Vierter Trigger
	self.Trigger4 = U1450_KTLF.Trigger4;
	self.TriggerIndex4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Trigger4#index"));
	addTrigger(self.TriggerIndex4, "Trigger4", self);
	self.enteredTrigger4 = false;
	
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));
		if self.hydraulics[i].punch ~= nil and self.hydraulics[i].translationPunch ~= nil then
			local ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
			self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
	end;
	
end;

function U1450_KTLF:Trigger1(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger1 = true;
		end;
	if onLeave then 
		self.enteredTrigger1 = false;
		end;
	end;
end;
function U1450_KTLF:Trigger2(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger2 = true;
		end;
	if onLeave then 
		self.enteredTrigger2 = false;
		end;
	end;
end;
function U1450_KTLF:Trigger3(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger3 = true;
		end;
	if onLeave then 
		self.enteredTrigger3 = false;
		end;
	end;
end;
function U1450_KTLF:Trigger4(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if (g_currentMission.controlledVehicle and otherId == g_currentMission.controlledVehicle.components[1].node) or (g_currentMission.player and otherId == g_currentMission.player.rootNode) then
		if onEnter then
			self.enteredTrigger4 = true;
		end;
	if onLeave then 
		self.enteredTrigger4 = false;
		end;
	end;
end;

function U1450_KTLF:readStream(streamId, connection)
	
end;

function U1450_KTLF:writeStream(streamId, connection)	
	
end;

function U1450_KTLF:delete()
	removeTrigger(self.TriggerIndex1, "Trigger1", self);
	removeTrigger(self.TriggerIndex2, "Trigger2", self);
	removeTrigger(self.TriggerIndex3, "Trigger3", self);
	removeTrigger(self.TriggerIndex4, "Trigger4", self);
	
end;

function U1450_KTLF:mouseEvent(posX, posY, isDown, isUp, button)
end;

function U1450_KTLF:keyEvent(unicode, sym, modifier, isDown)
end;

function U1450_KTLF:update(dt)
	if self.enteredTrigger1 then 
		if InputBinding.isPressed(InputBinding.U1450_1) then 
			self:setAnimationTime(1, self.animationParts[1].currentPosition+(self.animationParts[1].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.U1450_2) then 
			self:setAnimationTime(1, self.animationParts[1].currentPosition-(self.animationParts[1].offSet*(dt/5)));
		end;		
		if self.animationParts[1].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_1")), InputBinding.U1450_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_2")), InputBinding.U1450_2);
		end;		
	end;
	if self.enteredTrigger2 then
		if InputBinding.isPressed(InputBinding.U1450_1) then 
			self:setAnimationTime(2, self.animationParts[2].currentPosition+(self.animationParts[2].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.U1450_2) then 
			self:setAnimationTime(2, self.animationParts[2].currentPosition-(self.animationParts[2].offSet*(dt/5)));
		end;
		if self.animationParts[2].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_1")), InputBinding.U1450_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_2")), InputBinding.U1450_2);
		end;		
	end;
	if self.enteredTrigger3 then
		if InputBinding.isPressed(InputBinding.U1450_1) then 
			self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.U1450_2) then 
			self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet*(dt/5)));
		end;
		if self.animationParts[3].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_1")), InputBinding.U1450_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_2")), InputBinding.U1450_2);
		end;		
	end;
	if self.enteredTrigger4 then
		if InputBinding.isPressed(InputBinding.U1450_1) then 
			self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[4].offSet*(dt/5)));
		end;
		if InputBinding.isPressed(InputBinding.U1450_2) then 
			self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet*(dt/5)));
		end;
		if self.animationParts[4].clip then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_1")), InputBinding.U1450_1);
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("U1450_2")), InputBinding.U1450_2);
		end;		
	end;
	
	
	
end;

function U1450_KTLF:triggerCallback(triggerId,otherId,onEnter,onLeave,onStay)
    if (triggerId == self.stateChange) then
        if (onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode) then
            self.changeAllowed = true;
        elseif (onLeave) then
            self.changeAllowed = false;
        end;
    end;
end;

function U1450_KTLF:updateTick(dt)

	for i=1, table.getn(self.hydraulics) do
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].fixPoint);
		if bx ~= nil and by ~= nil and bz ~= nil then
			local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);
			setDirection(self.hydraulics[i].node, x, y, z, 0, 0, 1);
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if self.hydraulics[i].punch ~= nil and self.hydraulics[i].punchDistance ~= nil and self.hydraulics[i].translationPunch then
				if self.hydraulics[i].doScale then
					local xScale, yScale, zScale = getScale(self.hydraulics[i].punch);
					local newScale = xScale * (distance / self.hydraulics[i].punchDistance);
					setScale(self.hydraulics[i].punch, 1, 1, newScale);
				else
					setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
				end;
			end;
		end;
	end;
	
end;

function U1450_KTLF:draw()
	


end;

function U1450_KTLF:onLeave()
	
end;